import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public class XpathSubStringDemo
{
		public static void main(String[] args) throws Exception
		{

				DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
				documentBuilderFactory.setNamespaceAware(true);
				DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
				Document doc = documentBuilder.parse("src/cricketTeam_info.xml");

				XPathFactory xpathFactory = XPathFactory.newInstance();
				XPath xpath = xpathFactory.newXPath();

				//XPath ancestor axis example
				XPathExpression expr = xpath.compile("//cricketer/ancestor::*");
				Node ancestor = (Node) expr.evaluate(doc, XPathConstants.NODE);
				System.out.println("The ancestor element is "+ancestor.getNodeName());

				//Acessing child tags of ancestor
				expr = xpath.compile("//ancestor::*/name/text()");
				NodeList nodeList = (NodeList) expr.evaluate(doc, XPathConstants.NODESET);
				System.out.println("The name element are ");
				for(int i = 0; i < nodeList.getLength(); i++)
				{
						System.out.println((i+1)+". "+nodeList.item(i).getNodeValue());
				}

		}
}
